#pragma once
#include "include/cef_app.h"
#include "webview_client.h"
#include "webview_js_handler.h"
#include "webview_client.h"

class WebviewApp : public CefApp, public CefBrowserProcessHandler,CefRenderProcessHandler
{
public:
    WebviewApp();

    // CefApp methods:
    CefRefPtr<CefBrowserProcessHandler> GetBrowserProcessHandler() override
    {
        return this;
    }

     CefRefPtr<CefRenderProcessHandler> GetRenderProcessHandler()
    {
        return this;
    }
    void UpdateFunName(const std::string &funcName)
    {
        fuc_name_= funcName;
    }
    void UpdateDelegate(WebviewClient *delegate)
    {
        delegate_ = delegate;
    }
    // CefBrowserProcessHandler methods:
    void OnContextInitialized() override;
    void OnWebKitInitialized() override;
     bool OnProcessMessageReceived(CefRefPtr<CefBrowser> browser,
                                          CefRefPtr<CefFrame> frame,
                                          CefProcessId source_process,
                                          CefRefPtr<CefProcessMessage> message) override;
    void OnBeforeCommandLineProcessing(
        const CefString &process_type,
        CefRefPtr<CefCommandLine> command_line) override;
    void OnContextCreated(CefRefPtr<CefBrowser> browser,
                          CefRefPtr<CefFrame> frame,
                          CefRefPtr<CefV8Context> context) override;

private:
    // Include the default reference counting implementation.
     std::string fuc_name_;
    // WebviewJSHandlerDelegate *delegate_;
     WebviewClient *delegate_;

     IMPLEMENT_REFCOUNTING(WebviewApp);
};