#include "webview_bridge.h"
#include "include/wrapper/cef_helpers.h"

void WebviewClient::OnAfterCreated(CefRefPtr<CefBrowser> browser)
{
    CEF_REQUIRE_UI_THREAD();
    //   ::MessageBox(NULL, L"OnAfterCreated", L"Tip", MB_OK);
    browser_ = browser;
}

bool WebviewClient::DoClose(CefRefPtr<CefBrowser> browser)
{
    CEF_REQUIRE_UI_THREAD();
    //   ::MessageBox(NULL, L"DoClose", L"Tip", MB_OK);
    return false;
}

void WebviewClient::OnBeforeClose(CefRefPtr<CefBrowser> browser)
{
    CEF_REQUIRE_UI_THREAD();
    //   ::MessageBox(NULL, L"OnBeforeClose", L"Tip", MB_OK);
    browser_ = nullptr;
}
bool WebviewClient::OnBeforePopup(CefRefPtr<CefBrowser> browser,
                                  CefRefPtr<CefFrame> frame,
                                  const CefString &target_url,
                                  const CefString &target_frame_name,
                                  WindowOpenDisposition target_disposition,
                                  bool user_gesture,
                                  const CefPopupFeatures &popupFeatures,
                                  CefWindowInfo &windowInfo,
                                  CefRefPtr<CefClient> &client,
                                  CefBrowserSettings &settings,
                                  CefRefPtr<CefDictionaryValue> &extra_info,
                                  bool *no_javascript_access)
{
    // ::MessageBox(NULL, L"OnBeforePopup", L"Tip", MB_OK);
    if (popup_window_policy_ == WebviewClientWindowOpenPolicy::InSameWindow)
    {
        browser_->GetMainFrame()->LoadURL(target_url);
        return true;
    }

    return false;
}
